---
updatedAt: 2026-05-27T12:53:27.000Z
agentTools:
  projectIndex: https://developer.onetrust.com/onetrust/llms.txt
---

# Add Attachments to Evidence Task Implementation

Use this API to attach files, a note or a link to a specific Evidence Task Implementation.

> 🗒 Things to Know
>
> - The files must first be uploaded to the OneTrust application using the [Upload File](https://developer.onetrust.com/onetrust/reference/fileupload) API. The `Id` and `Name` parameter values returned in the [Upload File](https://developer.onetrust.com/onetrust/reference/fileupload) API response are required in the request body for this API.

# OpenAPI definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "Tech Risk & Compliance - IT Risk Management",
    "description": "The IT Risk Management API provides comprehensive REST endpoints for managing enterprise security controls, threats, vulnerabilities, and their implementations with OAuth2 security and extensive customization capabilities.",
    "version": "1.0",
    "contact": {
      "name": "OneTrust Support",
      "url": "https://my.onetrust.com/s/contactsupport"
    },
    "license": {
      "name": "Apache 2.0",
      "url": "https://www.apache.org/licenses/LICENSE-2.0"
    }
  },
  "servers": [
    {
      "url": "https://{hostname}",
      "variables": {
        "hostname": {
          "default": "hostname",
          "description": "The OneTrust hostname such as app.onetrust.com, app-eu.onetrust.com, app-de.onetrust.com, app-uk.onetrust.com, app-apac.onetrust.com, trial.onetrust.com, or uat.onetrust.com."
        }
      }
    }
  ],
  "tags": [
    {
      "name": "Evidence Task Implementations",
      "description": "APIs to manage evidence collection tasks including implementation retrieval, attachment handling (files, links, notes), and comprehensive search with interval-based collection tracking.",
      "externalDocs": {
        "description": "OpenAPI 3.1.0 - Download Definition",
        "url": "https://developer.onetrust.com/onetrust/openapi/tech-risk-compliance-it-risk-management.json"
      },
      "x-displayName": "Evidence Task Implementations"
    }
  ],
  "paths": {
    "/api/controls/v1/evidence-task-implementations/{evidenceTaskImplementationId}/attachments": {
      "post": {
        "operationId": "addEvidenceImplementationAttachment",
        "summary": "Add Attachments to Evidence Task Implementation",
        "description": "Use this API to attach files, a note or a link to a specific Evidence Task Implementation.\n\n> 🗒 Things to Know\n>\n> - The files must first be uploaded to the OneTrust application using the [Upload File](https://developer.onetrust.com/onetrust/reference/fileupload) API. The `Id` and `Name` parameter values returned in the [Upload File](https://developer.onetrust.com/onetrust/reference/fileupload) API response are required in the request body for this API.",
        "tags": [
          "Evidence Task Implementations"
        ],
        "x-onetrust": {
          "spec-label": "https://developer.onetrust.com/onetrust/openapi/tech-risk-compliance-it-risk-management.json"
        },
        "parameters": [
          {
            "name": "evidenceTaskImplementationId",
            "in": "path",
            "description": "The unique identifier (UUID) of the evidence task implementation.",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid",
              "example": "123e4567-e89b-12d3-a456-426614174000"
            }
          }
        ],
        "requestBody": {
          "required": true,
          "content": {
            "application/json": {
              "schema": {
                "description": "Request containing attachment details to be added to the evidence task implementation.",
                "type": "string",
                "oneOf": [
                  {
                    "$ref": "#/components/schemas/TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationAttachmentFileRequest"
                  },
                  {
                    "$ref": "#/components/schemas/TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationAttachmentLinkRequest"
                  },
                  {
                    "$ref": "#/components/schemas/TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationAttachmentNoteRequest"
                  }
                ]
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK"
          },
          "400": {
            "description": "Bad Request"
          },
          "401": {
            "description": "Unauthorized"
          },
          "403": {
            "description": "Forbidden"
          },
          "429": {
            "description": "Too Many Requests. \nFor more information, see [API Rate Limits](https://developer.onetrust.com/onetrust/reference/rate-limits-overview).",
            "headers": {
              "Retry-After": {
                "schema": {
                  "description": "The number of seconds after which requests will be allowed again.",
                  "format": "int32"
                }
              },
              "ot-period": {
                "schema": {
                  "description": "The unit of time for which the rate limit applies",
                  "enum": [
                    "HOUR",
                    "MINUTE"
                  ]
                }
              },
              "ot-ratelimit-event-id": {
                "schema": {
                  "description": "The unique identifier for the rate-limiting event.",
                  "format": "uuid"
                }
              },
              "ot-request-made": {
                "schema": {
                  "description": "The number of requests made within the specified period.",
                  "format": "int32"
                }
              },
              "ot-requests-allowed": {
                "schema": {
                  "description": "The number of requests allowed within the specified period.",
                  "format": "int32"
                }
              }
            }
          },
          "500": {
            "description": "Internal Server Error"
          }
        },
        "security": [
          {
            "TechRiskCompliance-ITRiskManagement_OAUTH2": [
              "CONTROL"
            ]
          }
        ]
      }
    }
  },
  "components": {
    "schemas": {
      "TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationAttachmentFileRequest": {
        "type": "object",
        "properties": {
          "collectionDate": {
            "description": "The date that the attachment was collected.",
            "type": "string",
            "format": "date",
            "example": "2021-01-01"
          },
          "documentType": {
            "description": "The type of attachment.",
            "type": "string",
            "example": "FILE",
            "enum": [
              "FILE",
              "NOTE",
              "LINK"
            ]
          },
          "evidenceTaskImplementationDocumentRequests": {
            "description": "The list of files to attach.",
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationDocumentRequest"
            },
            "minItems": 1
          }
        },
        "required": [
          "collectionDate",
          "documentType",
          "evidenceTaskImplementationDocumentRequests"
        ]
      },
      "TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationDocumentRequest": {
        "type": "object",
        "properties": {
          "attachmentId": {
            "description": "The unique identifier of the attachment.",
            "type": "string",
            "format": "uuid",
            "example": "1a2b3c4e-5f6g-7h8i-9j0k-1l2m3n4o5p6q"
          },
          "name": {
            "description": "The name of the attachment.",
            "type": "string",
            "example": "Attachment Name"
          }
        },
        "required": [
          "attachmentId",
          "name"
        ]
      },
      "TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationAttachmentLinkRequest": {
        "type": "object",
        "properties": {
          "collectionDate": {
            "description": "The date that the attachment was collected.",
            "type": "string",
            "format": "date",
            "example": "2021-01-01"
          },
          "documentType": {
            "description": "The type of attachment.",
            "type": "string",
            "example": "FILE",
            "enum": [
              "FILE",
              "NOTE",
              "LINK"
            ]
          },
          "url": {
            "description": "The URL to attach.",
            "type": "string",
            "format": "url",
            "example": "https://example.com/link"
          },
          "description": {
            "description": "The description of the URL.",
            "type": "string",
            "example": "Link Description"
          },
          "name": {
            "description": "The name of the attachment.",
            "type": "string",
            "example": "Attachment Name"
          }
        },
        "required": [
          "collectionDate",
          "description",
          "documentType",
          "name",
          "url"
        ]
      },
      "TechRiskCompliance-ITRiskManagement_EvidenceTaskImplementationAttachmentNoteRequest": {
        "type": "object",
        "properties": {
          "collectionDate": {
            "description": "The date that the attachment was collected.",
            "type": "string",
            "format": "date",
            "example": "2021-01-01"
          },
          "documentType": {
            "description": "The type of attachment.",
            "type": "string",
            "example": "FILE",
            "enum": [
              "FILE",
              "NOTE",
              "LINK"
            ]
          },
          "note": {
            "description": "The note to attach.",
            "type": "string",
            "example": "Note"
          },
          "name": {
            "description": "The name of the attachment.",
            "type": "string",
            "example": "Attachment Name"
          }
        },
        "required": [
          "collectionDate",
          "documentType",
          "name",
          "note"
        ]
      }
    },
    "securitySchemes": {
      "TechRiskCompliance-ITRiskManagement_OAUTH2": {
        "type": "oauth2",
        "flows": {
          "clientCredentials": {
            "tokenUrl": "https://{hostname}/api/access/v1/oauth/token",
            "scopes": {
              "CONTROL": "Access to Control Implementation operations for external systems",
              "ITRM": "Access to ITRM operations for external systems"
            }
          }
        }
      }
    }
  },
  "x-readme": {
    "explorer-enabled": false,
    "proxy-enabled": false,
    "metrics-enabled": false
  },
  "x-onetrust": {
    "spec-label": "OpenAPI 3.1.0"
  }
}
```

# Sibling pages

* [Get List of Evidence Task Implementations](https://developer.onetrust.com/onetrust/reference/findallevidencesbysearchcriteria_1-1.md)
* [Get Evidence Task Implementation](https://developer.onetrust.com/onetrust/reference/findevidenceimplementationsbyid_1-1.md)